package Cs;

my $pkg="Cs";

use strict;
#use My;
use Unicode::Map8;
use Unicode::String;


#== Konverze cestiny z HTML entit do ??
sub cshtml2cs {
   my ($pkg_p, $str,$charset_t)=@_;
   my $filename="/tmp/recode_".$$;
   #open(RECODE,'|/usr/bin/recode HTML-i18n..'.$charset_t.' > '.$filename);
   ## !!!!!!!!!!!!!!!!!!
   ## Nize uzivam specialni verzi recode - ne tu s deb balicku,
   ## kde jsem upravil zdrojak "recode-3.6/src/html.c" tak, aby
   ## nebyla provadena konverze znaku &amp;&gt;&lt;&quot;&nbsp;
   ## dale jsem pozdeji pridal: reckou abecedu (&#913; az &#982;),
   ##                           euro (&#8364;),
   ##                           micro (&#181;), plusminus (&#177;) a
   ##                           specialni uvozovky (&#8220; az &#8222;)
   ##                           matematicke symboly (&#8472; az &#9830;)
   ## slo o to u techto znaku ve zdrojaku maznout "| V40"
   my $E_PATH=$ENV{'PATH'}; delete($ENV{'PATH'}); # pod suidperlem by radek nize nejel, ale diky likvidaci promene prostredi PATH pojede
   # 2003-12-22, pridal jsem zatim prepinac "-f", aby nedocazelo k hrouceni pri konverzi problematickych znaku; do budoucna to chce nejak tu konverzi cestiny asi predelat (nejlepsi by bylo, kdyby se opisy problematickych znaku neprevadely)
   open(RECODE,'|/usr/local/bin/recode -f HTML..'.$charset_t.' > '.$filename);
   $ENV{'PATH'}=$E_PATH; # vraceni promene prostredi PATH do puvodniho stavu
   print RECODE $str;
   close(RECODE);
   $str='';
   open(RECODE,$filename);
   while(my $line=<RECODE>) {
      $str.=$line;
   }
   close(RECODE);
   unlink($filename);
   return $str;
}

#== Konverze cestiny z HTML entit do ?? - tahle verze nefunguje v mod_perl
sub cshtml2cs_OLD {
   my ($pkg_p, $str,$charset_t)=@_;
   open(RECODE,'|/usr/bin/recode HTML..'.$charset_t.'|');
   print RECODE $str;
   $str='';
   while(my $line=<RECODE>) {
      $str.=$line;
   }
   close(RECODE);
   return $str;
}

#== Konverze cestiny z UTF-8 na co chces
sub utf2cs {
   my ($pkg_p, $str,$charset_t)=@_;
   if($charset_t ne "UTF-8") {
      if($charset_t ne "US-ASCII") {
         my $map_t=Unicode::Map8->new($charset_t) || die $charset_t;
         $str=Unicode::String::utf8($str); # "oznameni", ze retezec je v UTF-8
         $str=$str->utf16; # prevod do UTF-16
         $str=$map_t->to8($str); # konverze z UTF-16 do prislusne 8bitove sady
      }
      else {
         require Cz::Cstocs;
         my $konvcs = new Cz::Cstocs 'utf8', $charset_t;
         $str=&$konvcs($str);
      }
   }
   return $str;
}

#== Konverze cestiny z jake chci na jakou chci (ale ne UTF-8)
sub cs2cs {
   my ($pkg_p, $str_s,$charset_s,$charset_t)=@_;
   my $str_t;
   if($charset_t ne "US-ASCII") {  # momentalni verze Unicode::Map8 totiz pri prenosu do US-ASCII proste ceske znaky jen vynecha - proto prevod do ascii resis knihovnou Cz::Cstocs
      my $map_s=Unicode::Map8->new($charset_s) || die $charset_s;
      my $map_t=Unicode::Map8->new($charset_t) || die $charset_t;
      $str_t=$map_s->recode8($map_t,$str_s);
   }
   else {
      require Cz::Cstocs;
      my $konvcs = new Cz::Cstocs $charset_s, $charset_t;
      $str_t=&$konvcs($str_s);
   }
   return $str_t;
}

return 1;

