package MySession;

my $pkg="MySession";

use strict;
use lib ("/home/web-maccess/www/lib");
use My;
use Apache::Session::MySQL;


#==== Globalni promena tohohle balicku
my $dbh=My->dbh;


#- fce cte zadane session $session_id a pak ho vrati
sub read {
   my ($pkg_p, $session_id)=@_;
   my %session_h;
   eval { # blok eval zajistuje, ze pokud neexistuje session $session_id, tak nedojde ke zhrouceni programu
      tie %session_h, "Apache::Session::MySQL", $session_id, {
         Handle     => $dbh,
         LockHandle => $dbh
      };
   };
   my $session=$session_h{MySession};
   untie %session_h;
   return $session;
}

#- fce zapisuje nove session a pak vrati jeho $session_id (pokud je na vstupu $session_id undef, tak bude vygenerovano nove)
sub write {
   my ($pkg_p, $session_id,$session)=@_;
   my %session_h;
   tie %session_h, "Apache::Session::MySQL", $session_id, {
      Handle     => $dbh,
      LockHandle => $dbh
   };
   $session_id=$session_h{_session_id};
   $session_h{MySession}=$session;
   untie %session_h;
   return $session_id;
}

return 1;

